
_ALL_LEDs_OFF:

;LED_Dice.c,12 :: 		void ALL_LEDs_OFF(){
;LED_Dice.c,13 :: 		PORTA = 0x00;
	CLRF       PORTA+0
;LED_Dice.c,14 :: 		TRISA = 0xFF;
	MOVLW      255
	MOVWF      TRISA+0
;LED_Dice.c,15 :: 		}
L_end_ALL_LEDs_OFF:
	RETURN
; end of _ALL_LEDs_OFF

_LED_ON:

;LED_Dice.c,19 :: 		void LED_ON(unsigned short num){
;LED_Dice.c,20 :: 		TRISA = TRISA_Data[num];
	MOVLW      _TRISA_Data+0
	MOVWF      FSR0L
	MOVLW      hi_addr(_TRISA_Data+0)
	MOVWF      FSR0H
	MOVF       FARG_LED_ON_num+0, 0
	ADDWF      FSR0L, 1
	BTFSC      STATUS+0, 0
	INCF       FSR0H, 1
	MOVF       INDF0+0, 0
	MOVWF      TRISA+0
;LED_Dice.c,21 :: 		PORTA = PORT_Data[num];
	MOVLW      _PORT_Data+0
	MOVWF      FSR0L
	MOVLW      hi_addr(_PORT_Data+0)
	MOVWF      FSR0H
	MOVF       FARG_LED_ON_num+0, 0
	ADDWF      FSR0L, 1
	BTFSC      STATUS+0, 0
	INCF       FSR0H, 1
	MOVF       INDF0+0, 0
	MOVWF      PORTA+0
;LED_Dice.c,22 :: 		}
L_end_LED_ON:
	RETURN
; end of _LED_ON

_interrupt:
	CLRF       PCLATH+0
	CLRF       STATUS+0

;LED_Dice.c,25 :: 		void interrupt(){
;LED_Dice.c,26 :: 		if(INTCON.INTF == 1) asm nop;
	BTFSS      INTCON+0, 1
	GOTO       L_interrupt0
	NOP
L_interrupt0:
;LED_Dice.c,27 :: 		INTCON.INTF = 0;
	BCF        INTCON+0, 1
;LED_Dice.c,28 :: 		}
L_end_interrupt:
L__interrupt16:
	RETFIE     %s
; end of _interrupt

_main:

;LED_Dice.c,30 :: 		void main() {
;LED_Dice.c,31 :: 		ANSELA = 0b00000000;  // RA0 analog input
	CLRF       ANSELA+0
;LED_Dice.c,32 :: 		TRISA  = 0b00001000;  // RA0 input, RA3 is input only
	MOVLW      8
	MOVWF      TRISA+0
;LED_Dice.c,33 :: 		PORTA = 0;
	CLRF       PORTA+0
;LED_Dice.c,34 :: 		OSCCON = 0b01101000;
	MOVLW      104
	MOVWF      OSCCON+0
;LED_Dice.c,35 :: 		INTCON = 0b10010000;
	MOVLW      144
	MOVWF      INTCON+0
;LED_Dice.c,36 :: 		OPTION_REG.INTEDG = 0; // External interrupt on falling edge of RA2/INT pin
	BCF        OPTION_REG+0, 6
;LED_Dice.c,37 :: 		Delay_ms(100);
	MOVLW      130
	MOVWF      R12
	MOVLW      221
	MOVWF      R13
L_main1:
	DECFSZ     R13, 1
	GOTO       L_main1
	DECFSZ     R12, 1
	GOTO       L_main1
	NOP
	NOP
;LED_Dice.c,40 :: 		do {
L_main2:
;LED_Dice.c,41 :: 		random_num = rand()%6 ;
	CALL       _rand+0
	MOVLW      6
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	CALL       _Div_16x16_S+0
	MOVF       R8, 0
	MOVWF      R0
	MOVF       R9, 0
	MOVWF      R1
	MOVF       R0, 0
	MOVWF      _random_num+0
	MOVF       R1, 0
	MOVWF      _random_num+1
;LED_Dice.c,42 :: 		for (j=0; j<=random_num+36; j++){
	CLRF       _j+0
	CLRF       _j+1
L_main5:
	MOVLW      36
	ADDWF      _random_num+0, 0
	MOVWF      R1
	MOVLW      0
	ADDWFC     _random_num+1, 0
	MOVWF      R2
	MOVF       _j+1, 0
	SUBWF      R2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main18
	MOVF       _j+0, 0
	SUBWF      R1, 0
L__main18:
	BTFSS      STATUS+0, 0
	GOTO       L_main6
;LED_Dice.c,43 :: 		i = j%6;
	MOVLW      6
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	MOVF       _j+0, 0
	MOVWF      R0
	MOVF       _j+1, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVF       R8, 0
	MOVWF      R0
	MOVF       R9, 0
	MOVWF      R1
	MOVF       R0, 0
	MOVWF      _i+0
	MOVF       R1, 0
	MOVWF      _i+1
;LED_Dice.c,44 :: 		LED_ON(i);
	MOVF       R0, 0
	MOVWF      FARG_LED_ON_num+0
	CALL       _LED_ON+0
;LED_Dice.c,45 :: 		for (k=0; k<=j/3; k++){
	CLRF       _k+0
	CLRF       _k+1
L_main8:
	MOVLW      3
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	MOVF       _j+0, 0
	MOVWF      R0
	MOVF       _j+1, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVF       _k+1, 0
	SUBWF      R1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main19
	MOVF       _k+0, 0
	SUBWF      R0, 0
L__main19:
	BTFSS      STATUS+0, 0
	GOTO       L_main9
;LED_Dice.c,46 :: 		Delay_ms(15);
	MOVLW      20
	MOVWF      R12
	MOVLW      121
	MOVWF      R13
L_main11:
	DECFSZ     R13, 1
	GOTO       L_main11
	DECFSZ     R12, 1
	GOTO       L_main11
	NOP
	NOP
;LED_Dice.c,45 :: 		for (k=0; k<=j/3; k++){
	INCF       _k+0, 1
	BTFSC      STATUS+0, 2
	INCF       _k+1, 1
;LED_Dice.c,47 :: 		}
	GOTO       L_main8
L_main9:
;LED_Dice.c,42 :: 		for (j=0; j<=random_num+36; j++){
	INCF       _j+0, 1
	BTFSC      STATUS+0, 2
	INCF       _j+1, 1
;LED_Dice.c,48 :: 		}
	GOTO       L_main5
L_main6:
;LED_Dice.c,49 :: 		Delay_ms(2500);
	MOVLW      13
	MOVWF      R11
	MOVLW      175
	MOVWF      R12
	MOVLW      182
	MOVWF      R13
L_main12:
	DECFSZ     R13, 1
	GOTO       L_main12
	DECFSZ     R12, 1
	GOTO       L_main12
	DECFSZ     R11, 1
	GOTO       L_main12
	NOP
;LED_Dice.c,50 :: 		ALL_LEDs_OFF();
	CALL       _ALL_LEDs_OFF+0
;LED_Dice.c,51 :: 		asm sleep;
	SLEEP
;LED_Dice.c,52 :: 		asm nop;
	NOP
;LED_Dice.c,53 :: 		} while(1);
	GOTO       L_main2
;LED_Dice.c,54 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
