/*
  Description: LED Dice Project
  Written By: Raj Bhatt (www.embedded-lab.com)
  Date: Nov 21, 2014
*/

// Define Charlieplexing lines
#define Row_A RA4_bit
#define Row_B RA5_bit
#define Row_C RA0_bit

// Define port direction and output states for each LED
const unsigned short TRISA_Data[]= \
               {0xCF, 0xCF, 0xDE, 0xDE, 0xEE, 0xEE};
const unsigned short PORT_Data[] = \
               {0x10, 0x20, 0x20, 0x01, 0x10, 0x01};
unsigned int j, i,k, random_num;

void ALL_LEDs_OFF(){
  PORTA = 0x00;
  TRISA = 0xFF;
}

void LED_ON(unsigned short num){
  TRISA = TRISA_Data[num];
  PORTA = PORT_Data[num];
}

// Interrupt service routine 
void interrupt(){ 
  if(INTCON.INTF == 1) asm nop;
  INTCON.INTF = 0;
}

void main() {
 ANSELA = 0b00000000;  // Disable analog inputs
 TRISA  = 0b00001000;  // RA3 is input only
 PORTA = 0;
 OSCCON = 0b01101000;  // Set internal clock to 4MHz
 INTCON = 0b10010000;  // Enable external hardware interrupt
 OPTION_REG.INTEDG = 0; // External interrupt on falling edge of RA2/INT pin
 Delay_ms(100);
 

do {
  random_num = rand()%6 ;
  for (j=0; j<=random_num+36; j++){
      i = j%6;
      LED_ON(i);
      for (k=0; k<=j/3; k++){
        Delay_ms(15);
      }
  }
  Delay_ms(2500);
  ALL_LEDs_OFF();
  asm sleep;
  asm nop;
 } while(1);
}